<template>
  <div class="view">
    <employee-navbar
      :page-title="pageTitle"
      :breadcrumb-menu="breadcrumbMenu"
      :is-secondary-page="isSecondaryPage"
      :page-type="pageType"
      @goTo="goTo"
    />
    <EmployeeView
      :table-fields="tableFields"
      :items="employees"
      @getTags="getTags"
      @viewEmployee="goTo"
      @editEmployee="goTo"
      @deactivateEmployee="onDeactivate"
      @activateEmployee="onActivate"
    />
  </div>
</template>

<script lang="ts">
import { Vue, Component } from 'nuxt-property-decorator'
import { provide, consume } from 'provide-consume-decorator'
import { getModule } from 'vuex-module-decorators'
import { Dictionary } from 'vue-router/types/router'
import EmployeeNavbar from '@/components/Employee/EmployeeNavbar.vue'
import EmployeeView from '@/components/Employee/EmployeeViewer/EmployeeView.vue'
import { Employee } from '@/types/employee'
import EmployeeStore from '@/store/modules/employee'

interface Store {
  employee: EmployeeStore
}

@Component({
  mixins: [{ methods: {} }],
  components: { EmployeeNavbar, EmployeeView },
  head() {
    return {
      title: `All Employees`,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: 'View all employees'
        }
      ]
    }
  }
})
@provide({
  store(): Store {
    return {
      employee: getModule(EmployeeStore, this.$store)
    }
  }
})
export default class Testing extends Vue {
  @consume('store') store!: Store

  private tableFields = [
    'avatar',
    'displayName',
    'lastName',
    'companyEmail',
    'tags',
    'birthdate',
    'startDate',
    'actions'
  ]

  private pageTitle = 'View & Manage Employees'

  private pageType = 'Index'

  private thirdLevelBreadcrumb = {
    cursor: 'default',
    'text-decoration': 'none',
    color: '#cacaca'
  }

  private breadcrumbMenu = [
    {
      text: 'Employees',
      style: this.thirdLevelBreadcrumb
    },
    {
      text: 'View & Manage',
      style: this.thirdLevelBreadcrumb
    }
  ]

  private isSecondaryPage = false

  get employees(): Employee[] {
    return this.store.employee.employees
  }

  mounted() {
    this.store.employee.getEmployees()
  }

  onDeactivate(id: string) {
    this.store.employee.deactivateEmployee(id)
  }

  onActivate(id: string) {
    this.store.employee.activateEmployee(id)
  }

  getTags(tags: string) {
    return (JSON.parse(tags) as string[]).join(', ')
  }

  goTo(name: string, id?: string) {
    const params = {} as Dictionary<string>
    if (id) {
      params.id = id
    }
    this.$router.push({ name, params })
  }
}
</script>
<style>
body {
  background-color: #eef2f3;
}

.employee-view {
  width: calc(100% - 250px);
  float: right;
}
</style>
